module CChokeProblems
    use CChokeProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
	subroutine SetHydraulicChoke1Plugged(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke1Plugged
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke1Plugged' :: SetHydraulicChoke1Plugged
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke1Plugged = SetDue(v, ChangeHydraulicChoke1Plugged)
#ifdef deb
	    print*, 'HydraulicChoke1Plugged%ProblemType=', ChokeProblems%HydraulicChoke1Plugged%ProblemType
	    print*, 'HydraulicChoke1Plugged%StatusType=', ChokeProblems%HydraulicChoke1Plugged%StatusType
	    print*, 'HydraulicChoke1Plugged%Value=', ChokeProblems%HydraulicChoke1Plugged%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke1Fail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke1Fail
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke1Fail' :: SetHydraulicChoke1Fail
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke1Fail = SetDue(v, ChangeHydraulicChoke1Fail)
#ifdef deb
	    print*, 'HydraulicChoke1Fail%ProblemType=', ChokeProblems%HydraulicChoke1Fail%ProblemType
	    print*, 'HydraulicChoke1Fail%StatusType=', ChokeProblems%HydraulicChoke1Fail%StatusType
	    print*, 'HydraulicChoke1Fail%Value=', ChokeProblems%HydraulicChoke1Fail%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke1Washout(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke1Washout
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke1Washout' :: SetHydraulicChoke1Washout
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke1Washout = SetDue(v, ChangeHydraulicChoke1Washout)
#ifdef deb
	    print*, 'HydraulicChoke1Washout%ProblemType=', ChokeProblems%HydraulicChoke1Washout%ProblemType
	    print*, 'HydraulicChoke1Washout%StatusType=', ChokeProblems%HydraulicChoke1Washout%StatusType
	    print*, 'HydraulicChoke1Washout%Value=', ChokeProblems%HydraulicChoke1Washout%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke1PluggedPercent(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke1PluggedPercent
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke1PluggedPercent' :: SetHydraulicChoke1PluggedPercent
		implicit none
		integer, intent(in) :: v
		ChokeProblems%HydraulicChoke1PluggedPercent = v
#ifdef deb
	    print*, 'HydraulicChoke1PluggedPercent=', ChokeProblems%HydraulicChoke1PluggedPercent
#endif
	end subroutine

	subroutine SetHydraulicChoke2Plugged(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke2Plugged
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke2Plugged' :: SetHydraulicChoke2Plugged
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke2Plugged = SetDue(v, ChangeHydraulicChoke2Plugged)
#ifdef deb
	    print*, 'HydraulicChoke2Plugged%ProblemType=', ChokeProblems%HydraulicChoke2Plugged%ProblemType
	    print*, 'HydraulicChoke2Plugged%StatusType=', ChokeProblems%HydraulicChoke2Plugged%StatusType
	    print*, 'HydraulicChoke2Plugged%Value=', ChokeProblems%HydraulicChoke2Plugged%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke2Fail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke2Fail
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke2Fail' :: SetHydraulicChoke2Fail
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke2Fail = SetDue(v, ChangeHydraulicChoke2Fail)
#ifdef deb
	    print*, 'HydraulicChoke2Fail%ProblemType=', ChokeProblems%HydraulicChoke2Fail%ProblemType
	    print*, 'HydraulicChoke2Fail%StatusType=', ChokeProblems%HydraulicChoke2Fail%StatusType
	    print*, 'HydraulicChoke2Fail%Value=', ChokeProblems%HydraulicChoke2Fail%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke2Washout(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke2Washout
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke2Washout' :: SetHydraulicChoke2Washout
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%HydraulicChoke2Washout = SetDue(v, ChangeHydraulicChoke2Washout)
#ifdef deb
	    print*, 'HydraulicChoke2Washout%ProblemType=', ChokeProblems%HydraulicChoke2Washout%ProblemType
	    print*, 'HydraulicChoke2Washout%StatusType=', ChokeProblems%HydraulicChoke2Washout%StatusType
	    print*, 'HydraulicChoke2Washout%Value=', ChokeProblems%HydraulicChoke2Washout%Value
#endif
	end subroutine

	subroutine SetHydraulicChoke2PluggedPercent(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetHydraulicChoke2PluggedPercent
	!DEC$ ATTRIBUTES ALIAS: 'SetHydraulicChoke2PluggedPercent' :: SetHydraulicChoke2PluggedPercent
		implicit none
		integer, intent(in) :: v
		ChokeProblems%HydraulicChoke2PluggedPercent = v
#ifdef deb
	    print*, 'HydraulicChoke2PluggedPercent=', ChokeProblems%HydraulicChoke2PluggedPercent
#endif
	end subroutine

	subroutine SetManualChoke1Plugged(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke1Plugged
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke1Plugged' :: SetManualChoke1Plugged
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke1Plugged = SetDue(v, ChangeManualChoke1Plugged)
#ifdef deb
	    print*, 'ManualChoke1Plugged%ProblemType=', ChokeProblems%ManualChoke1Plugged%ProblemType
	    print*, 'ManualChoke1Plugged%StatusType=', ChokeProblems%ManualChoke1Plugged%StatusType
	    print*, 'ManualChoke1Plugged%Value=', ChokeProblems%ManualChoke1Plugged%Value
#endif
	end subroutine

	subroutine SetManualChoke1Fail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke1Fail
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke1Fail' :: SetManualChoke1Fail
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke1Fail = SetDue(v, ChangeManualChoke1Fail)
#ifdef deb
	    print*, 'ManualChoke1Fail%ProblemType=', ChokeProblems%ManualChoke1Fail%ProblemType
	    print*, 'ManualChoke1Fail%StatusType=', ChokeProblems%ManualChoke1Fail%StatusType
	    print*, 'ManualChoke1Fail%Value=', ChokeProblems%ManualChoke1Fail%Value
#endif
	end subroutine

	subroutine SetManualChoke1Washout(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke1Washout
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke1Washout' :: SetManualChoke1Washout
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke1Washout = SetDue(v, ChangeManualChoke1Washout)
#ifdef deb
	    print*, 'ManualChoke1Washout%ProblemType=', ChokeProblems%ManualChoke1Washout%ProblemType
	    print*, 'ManualChoke1Washout%StatusType=', ChokeProblems%ManualChoke1Washout%StatusType
	    print*, 'ManualChoke1Washout%Value=', ChokeProblems%ManualChoke1Washout%Value
#endif
	end subroutine

	subroutine SetManualChoke1PluggedPercent(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke1PluggedPercent
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke1PluggedPercent' :: SetManualChoke1PluggedPercent
		implicit none
		integer, intent(in) :: v
		ChokeProblems%ManualChoke1PluggedPercent = v
#ifdef deb
	    print*, 'ManualChoke1PluggedPercent=', ChokeProblems%ManualChoke1PluggedPercent
#endif
	end subroutine

	subroutine SetManualChoke2Plugged(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke2Plugged
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke2Plugged' :: SetManualChoke2Plugged
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke2Plugged = SetDue(v, ChangeManualChoke2Plugged)
#ifdef deb
	    print*, 'ManualChoke2Plugged%ProblemType=', ChokeProblems%ManualChoke2Plugged%ProblemType
	    print*, 'ManualChoke2Plugged%StatusType=', ChokeProblems%ManualChoke2Plugged%StatusType
	    print*, 'ManualChoke2Plugged%Value=', ChokeProblems%ManualChoke2Plugged%Value
#endif
	end subroutine

	subroutine SetManualChoke2Fail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke2Fail
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke2Fail' :: SetManualChoke2Fail
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke2Fail = SetDue(v, ChangeManualChoke2Fail)
#ifdef deb
	    print*, 'ManualChoke2Fail%ProblemType=', ChokeProblems%ManualChoke2Fail%ProblemType
	    print*, 'ManualChoke2Fail%StatusType=', ChokeProblems%ManualChoke2Fail%StatusType
	    print*, 'ManualChoke2Fail%Value=', ChokeProblems%ManualChoke2Fail%Value
#endif
	end subroutine

	subroutine SetManualChoke2Washout(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManualChoke2Washout
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke2Washout' :: SetManualChoke2Washout
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ManualChoke2Washout = SetDue(v, ChangeManualChoke2Washout)
#ifdef deb
	    print*, 'ManualChoke2Washout%ProblemType=', ChokeProblems%ManualChoke2Washout%ProblemType
	    print*, 'ManualChoke2Washout%StatusType=', ChokeProblems%ManualChoke2Washout%StatusType
	    print*, 'ManualChoke2Washout%Value=', ChokeProblems%ManualChoke2Washout%Value
#endif
	end subroutine

	subroutine SetManualChoke2PluggedPercent(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetManu alChoke2PluggedPercent
	!DEC$ ATTRIBUTES ALIAS: 'SetManualChoke2PluggedPercent' :: SetManualChoke2PluggedPercent
		implicit none
		integer, intent(in) :: v
		ChokeProblems%ManualChoke2PluggedPercent = v
#ifdef deb
	    print*, 'ManualChoke2PluggedPercent=', ChokeProblems%ManualChoke2PluggedPercent
#endif
	end subroutine

	subroutine SetChokePanelAirFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetChokePanelAirFail
	!DEC$ ATTRIBUTES ALIAS: 'SetChokePanelAirFail' :: SetChokePanelAirFail
		implicit none
		type(CProblem), intent(in) :: v
		ChokeProblems%ChokePanelAirFail = SetDue(v, ChangeChokePanelAirFail)
#ifdef deb
	    print*, 'ChokePanelAirFail%ProblemType=', ChokeProblems%ChokePanelAirFail%ProblemType
	    print*, 'ChokePanelAirFail%StatusType=', ChokeProblems%ChokePanelAirFail%StatusType
	    print*, 'ChokePanelAirFail%Value=', ChokeProblems%ChokePanelAirFail%Value
#endif
    end subroutine

end module CChokeProblems