module CLostProblems
	use CLostProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    subroutine SetLostCirculation(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLostCirculation
    !DEC$ ATTRIBUTES ALIAS: 'SetLostCirculation' :: SetLostCirculation
	    implicit none
	    type(CProblem), intent(in) :: v
	    LostProblems%LostCirculation = SetDue(v, ChangeLostCirculation)
#ifdef deb
	    print*, 'LostCirculation%ProblemType=', LostProblems%LostCirculation%ProblemType
	    print*, 'LostCirculation%StatusType=', LostProblems%LostCirculation%StatusType
	    print*, 'LostCirculation%Value=', LostProblems%LostCirculation%Value
#endif
    end subroutine

    subroutine SetFlowRate(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetFlowRate
    !DEC$ ATTRIBUTES ALIAS: 'SetFlowRate' :: SetFlowRate
	    implicit none
	    real*8, intent(in) :: v
	    LostProblems%FlowRate = v
#ifdef deb
	print*, 'FlowRate=', LostProblems%FlowRate
#endif
    end subroutine
    
end module CLostProblems