    SUBROUTINE Choke_StartUp()
    
    USE CHOKEVARIABLES
    USE CChokeProblemsVariables
    implicit none 
    
  CALL LOSS_INPUTS_CHOKE()
    
    !OPEN(150,FILE='CHOKE_AIRPUMP_OUTPUTS.DAT')
    
    
    !CHOOKE(1)%WashoutMalf=1
    !CHOOKE(1)%PlugMalf=0
    !CHOOKE(1)%FailMalf=0
    !
    !CHOOKE(2)%WashoutMalf=1
    !CHOOKE(2)%PlugMalf=0
    !CHOOKE(2)%FailMalf=0 
    !
    !
    !ChokeAirFail=0
    !
    !GaugeChokePositionMailf=0

    
    
    
    
    
    
    Choke%kRatio=1.4
Choke%Cp=0.24
Choke%CL=0.8

Choke%x1=0.5  
 
Choke%LiquidPPG=9.
Choke%LiquidDensity=Choke%LiquidPPG*7.48 !lbm/ft**3

Choke%VL=1.0/Choke%LiquidDensity   !SpecificVolume of Liquid

Choke%Cv=Choke%Cp/Choke%kRatio

Choke%nPolytripic=1+(Choke%x1*(Choke%Cp-Choke%Cv)/(Choke%x1*Choke%Cv+(1-Choke%x1)*Choke%CL))
    
Choke%VG1=1./0.748    !lbm/ft**3 Specific Volume of Air, Upstream

Choke%Cdrag=0.8
Choke%Pwh=1400. !psi


Choke%Patm=14.7
Choke%MixDens2=Choke%x1*Choke%VG1 !lbm/ft**3



Choke%epsilon_abs= 1e-5
Choke%epsilon_step= 1e-5


!ChokeDiameter= 32/64.  !in

CHOOKE%PercentClose= 0.0
       !AreaChoke=0.01334635

  ! CHOOKE(1)%AreaChoke=0.01334635
!ChokeAreaFullyOpen = 123.d0 / 64.d0     ! fully open area is 123/64 in^2 = 0.01334635 ft^2

AirPumpLine%DeltaT_Choke=0.1
!TotalStrokes1=0.
!TotalStrokes2=0.

Choke%HydraulicChoke1WashoutCoef= 0.0
Choke%HydraulicChoke2WashoutCoef= 0.0



Choke%ChokePlugTimeDelay = int(180./AirPumpLine%DeltaT_Choke)       ! =1800 = 180/0.1 : for 3 min delay

Choke%Present_HydraulicChoke1Plug = REAL(ChokeProblems%HydraulicChoke1PluggedPercent)/100.
Choke%HydraulicChoke1PluggedPercent_Old= ChokeProblems%HydraulicChoke1PluggedPercent
Choke%Plug1TimeCounter= 0
Choke%DeltaPlug1Percent = 0.0

Choke%Present_HydraulicChoke2Plug = REAL(ChokeProblems%HydraulicChoke2PluggedPercent)/100.
Choke%HydraulicChoke2PluggedPercent_Old= ChokeProblems%HydraulicChoke2PluggedPercent
Choke%Plug2TimeCounter= 0
Choke%DeltaPlug2Percent = 0.0




    

!======================AIRPUMP INPUTS(CONSTANTS)===========================
    AirPumpLine%CourseBase= 24. !cm
    CHOOKE%PassedCourse= 0.
    ChokeControlPanel%ChokePosition=0.

    AirPumpLine%Acylinder= PI*(8.**2)/4.        !  (CM^2),  8=DIAMETER,   24=course ,  3785.412: cm^3 to galon


    CHOOKE%ChokeIsOpening = .false.
    CHOOKE%ChokeIsClosing = .false. 
         
         
    AirPumpLine%P_AIRP=0

    AirDrivenPump%cc1 =  0.1354; AirDrivenPump%cc2 = -2.066; AirDrivenPump%cc3 = -21.09; AirDrivenPump%cc4 = -51.36; AirDrivenPump%cc5 = 5935           ! FOR OUTPUT IN GPM
    ! cc1 = 4.754e-07; cc2 = -0.0001676; cc3 = -0.03953; cc4 = -2.223; cc5 = 5935         FOR OUTPUT IN IN^3/MIN


AirPumpLine%Pdownstrem= 4950 !+0.01*Pchoke   (psi)       <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
AirPumpLine%QITER=5.  !(gpm)

! Q=0.0003585; true
AirPumpLine%TIME=0
AirPumpLine%TOL_AIR=0.05

AirPumpLine%alpha_Qair=0
AirPumpLine%alpha_timeair=0
AirPumpLine%alpha_Pdownstrem=AirPumpLine%Pdownstrem
AirPumpLine%alpha_diffpair=0
AirPumpLine%alpha_lossesair=0












    end