module CBitProblems
	use CBitProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    subroutine SetPlugJets(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPlugJets
    !DEC$ ATTRIBUTES ALIAS: 'SetPlugJets' :: SetPlugJets
	    implicit none
	    type(CProblem), intent(in) :: v
	    BitProblems%PlugJets = SetDue(v, ChangePlugJets)
#ifdef deb
	    !print*, 'PlugJets%ProblemType=', PlugJets%ProblemType
	    !print*, 'PlugJets%StatusType=', PlugJets%StatusType
	    !print*, 'PlugJets%Value=', PlugJets%Value
	    !print*, 'PlugJets%DueValue=', PlugJets%DueValue
        
        call Log_3("==============================")
        call Log_3("PlugJets%ProblemType=", BitProblems%PlugJets%ProblemType)
	    call Log_3("PlugJets%StatusType=", BitProblems%PlugJets%StatusType)
	    call Log_3("PlugJets%Value=", BitProblems%PlugJets%Value)
	    call Log_3("PlugJets%DueValue=", BitProblems%PlugJets%DueValue)
        call Log_3("==============================")
#endif
    end subroutine

    subroutine SetJetWashout(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetJetWashout
    !DEC$ ATTRIBUTES ALIAS: 'SetJetWashout' :: SetJetWashout
	    implicit none
	    type(CProblem), intent(in) :: v
	    BitProblems%JetWashout = SetDue(v, ChangeJetWashout)
#ifdef deb
	    print*, 'JetWashout%ProblemType=', BitProblems%JetWashout%ProblemType
	    print*, 'JetWashout%StatusType=', BitProblems%JetWashout%StatusType
	    print*, 'JetWashout%Value=', BitProblems%JetWashout%Value
	    print*, 'JetWashout%DueValue=', BitProblems%JetWashout%DueValue
#endif
    end subroutine

    subroutine SetPlugJetsCount(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPlugJetsCount
    !DEC$ ATTRIBUTES ALIAS: 'SetPlugJetsCount' :: SetPlugJetsCount
	    implicit none
	    integer, intent(in) :: v
	    BitProblems%PlugJetsCount = v
#ifdef deb
	    print*, 'PlugJetsCount=', BitProblems%PlugJetsCount
#endif
    end subroutine

    subroutine SetJetWashoutCount(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetJetWashoutCount
    !DEC$ ATTRIBUTES ALIAS: 'SetJetWashoutCount' :: SetJetWashoutCount
	    implicit none
	    integer, intent(in) :: v
	    BitProblems%JetWashoutCount = v
#ifdef deb
	    print*, 'JetWashoutCount=', BitProblems%JetWashoutCount
#endif
    end subroutine
    
end module CBitProblems