module CDrillStemProblems
	use CDrillStemProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    subroutine SetStringDragIncrease(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringDragIncrease
    !DEC$ ATTRIBUTES ALIAS: 'SetStringDragIncrease' :: SetStringDragIncrease
	    implicit none
	    type(CProblem), intent(in) :: v
	    DrillStemProblems%StringDragIncrease = SetDue(v, ChangeStringDragIncrease)
#ifdef deb
	    print*, 'StringDragIncrease%ProblemType=', DrillStemProblems%StringDragIncrease%ProblemType
	    print*, 'StringDragIncrease%StatusType=', DrillStemProblems%StringDragIncrease%StatusType
	    print*, 'StringDragIncrease%Value=', DrillStemProblems%StringDragIncrease%Value
#endif
    end subroutine

    subroutine SetStringTorqueIncrease(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueIncrease
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueIncrease' :: SetStringTorqueIncrease
	    implicit none
	    type(CProblem), intent(in) :: v
	    DrillStemProblems%StringTorqueIncrease = SetDue(v, ChangeStringTorqueIncrease)
#ifdef deb
	    print*, 'StringTorqueIncrease%ProblemType=', DrillStemProblems%StringTorqueIncrease%ProblemType
	    print*, 'StringTorqueIncrease%StatusType=', DrillStemProblems%StringTorqueIncrease%StatusType
	    print*, 'StringTorqueIncrease%Value=', DrillStemProblems%StringTorqueIncrease%Value
#endif
    end subroutine

    subroutine SetStringTorqueFluctuation(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueFluctuation
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueFluctuation' :: SetStringTorqueFluctuation
	    implicit none
	    type(CProblem), intent(in) :: v
	    DrillStemProblems%StringTorqueFluctuation = SetDue(v, ChangeStringTorqueFluctuation)
#ifdef deb
	    print*, 'StringTorqueFluctuation%ProblemType=', DrillStemProblems%StringTorqueFluctuation%ProblemType
	    print*, 'StringTorqueFluctuation%StatusType=', DrillStemProblems%StringTorqueFluctuation%StatusType
	    print*, 'StringTorqueFluctuation%Value=', DrillStemProblems%StringTorqueFluctuation%Value
#endif
    end subroutine

    subroutine SetStringDragIncreaseTime(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringDragIncreaseTime
    !DEC$ ATTRIBUTES ALIAS: 'SetStringDragIncreaseTime' :: SetStringDragIncreaseTime
	    implicit none
	    real(8), intent(in) :: v
	    DrillStemProblems%StringDragIncreaseTime = v
#ifdef deb
	print*, 'StringDragIncreaseTime=', DrillStemProblems%StringDragIncreaseTime
#endif
    end subroutine

    subroutine SetStringTorqueIncreaseTime(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueIncreaseTime
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueIncreaseTime' :: SetStringTorqueIncreaseTime
	    implicit none
	    real(8), intent(in) :: v
	    DrillStemProblems%StringTorqueIncreaseTime = v
#ifdef deb
	print*, 'StringTorqueIncreaseTime=', DrillStemProblems%StringTorqueIncreaseTime
#endif
    end subroutine
    
end module CDrillStemProblems