module CHoistingProblems
    use CHoistingProblemsVariables
	implicit none    
	public 
    contains
    
    ! Input routines
	subroutine SetMotorFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMotorFail
	!DEC$ ATTRIBUTES ALIAS: 'SetMotorFail' :: SetMotorFail
		implicit none
		type(CProblem), intent(in) :: v
		HoistingProblems%MotorFail = SetDue(v, ChangeMotorFail)
#ifdef deb
	    print*, 'MotorFail%ProblemType=', HoistingProblems%MotorFail%ProblemType
	    print*, 'MotorFail%StatusType=', HoistingProblems%MotorFail%StatusType
	    print*, 'MotorFail%Value=', HoistingProblems%MotorFail%Value
#endif
	end subroutine

	subroutine SetClutchEngage(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetClutchEngage
	!DEC$ ATTRIBUTES ALIAS: 'SetClutchEngage' :: SetClutchEngage
		implicit none
		type(CProblem), intent(in) :: v
		HoistingProblems%ClutchEngage = SetDue(v, ChangeClutchEngage)
#ifdef deb
	    print*, 'ClutchEngage%ProblemType=', HoistingProblems%ClutchEngage%ProblemType
	    print*, 'ClutchEngage%StatusType=', HoistingProblems%ClutchEngage%StatusType
	    print*, 'ClutchEngage%Value=', HoistingProblems%ClutchEngage%Value
#endif
	end subroutine

	subroutine SetClutchDisengage(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetClutchDisengage
	!DEC$ ATTRIBUTES ALIAS: 'SetClutchDisengage' :: SetClutchDisengage
		implicit none
		type(CProblem), intent(in) :: v
		HoistingProblems%ClutchDisengage = SetDue(v, ChangeClutchDisengage)
#ifdef deb
	    print*, 'ClutchDisengage%ProblemType=', HoistingProblems%ClutchDisengage%ProblemType
	    print*, 'ClutchDisengage%StatusType=', HoistingProblems%ClutchDisengage%StatusType
	    print*, 'ClutchDisengage%Value=', HoistingProblems%ClutchDisengage%Value
#endif
    end subroutine

end module CHoistingProblems