subroutine Pumps_StartUp
    
    !use CPumpsVariables
    !use CDrillingConsoleVariables
    !use CDataDisplayConsoleVariables
    !! use CSimulationVariables
    !use CPowerVariables
    use Pumps_VARIABLES
    
    
	IMPLICIT NONE
    
    
  
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 1  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    PUMP(1)%FlowRatePerSTK  = 7000.e0     ![bbl]  !??????? motaghayere voroudi
    !PUMP(1)%FlowRatePerSTK  = PUMP(1)%FlowRatePerSTK*0.0292e0      ![gpm]
    PUMP(1)%RateChange      = 4.e0      ! [stk/min2]   !??????? motaghayere voroudi
    PUMP(1)%Stroke_Length   = 12.e0!MudPump1Stroke   ! bayad hazf beshe ?
    PUMP(1)%Piston_Diameter = 4.e0!MudPump1LinerDiameter   ! bayad hazf beshe ?
    PUMP(1)%Piston_Area     = (pi*(PUMP(1)%Piston_Diameter**2.e0))/4.e0   ! bayad hazf beshe ?
    PUMP(1)%Mech_Efficiency = 0.95e0!MudPump1MechanicalEfficiency    [dimensionless]
    !PUMP(1)%Vol_Efficiency  = MudPump1VolumetricEfficiency     ! bayad hazf beshe ?
    !PUMP(1)%Max_Horsepower  = MudPump1    ! bayad hazf beshe ?
    PUMP(1)%Max_Pressure    = 600.e0     ! [psi]  !??????? motaghayere voroudi
    PUMP(1)%MaxSPM          = 275.e0!MudPump1Maximum      [spm]
    PUMP(1)%Trans_Ratio     = 965.e0/PUMP(1)%MaxSPM
    PUMP(1)%time_step       = 0.1e0   !?????? niaz hast ya na??
    
    PUMP(1)%RateChange = PUMP(1)%RateChange*PUMP(1)%Trans_Ratio      ! [rpm/min2]
    PUMP(1)%K_throttle = 0
    Pumps_IsStopped    = .false.
    PUMP(1)%N_old      = 0.e0
    Call Pump_OffMode_Solver(1)  
    
    
    
    
!!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 2  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    !PUMP(2)%Stroke_Length   = MudPump2Stroke
    !PUMP(2)%Piston_Diameter = MudPump2LinerDiameter
    !PUMP(2)%Piston_Area     = pi*PUMP(2)%Piston_Diameter*PUMP(2)%Piston_Diameter/4.
    !PUMP(2)%Mech_Efficiency = MudPump2MechanicalEfficiency
    !PUMP(2)%Vol_Efficiency  = MudPump2VolumetricEfficiency
    !PUMP(2)%Max_Horsepower  = MudPump2
    !PUMP(2)%Inertia_Moment  = 23.261341  ! 23.261341 [kg.m^2] = 552 [lb.ft^2]
    !PUMP(2)%J_coef          = PUMP(2)%Inertia_Moment+(4.*(PUMP(2)%Inertia_Moment))
    !PUMP(2)%Trans_Ratio     = 965.0/MudPump2Maximum
    !PUMP(2)%time_step       = .10
    !
    !PUMP(2)%Flow_Rate       = 0.
    !Call Pump2_OffMode_Solver(2)
    
    
    
    
    
!!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 3  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    !PUMP(3)%Stroke_Length   = CementPumpStroke
    !PUMP(3)%Piston_Diameter = CementPumpLinerDiameter
    !PUMP(3)%Piston_Area     = pi*PUMP(3)%Piston_Diameter*PUMP(3)%Piston_Diameter/4.
    !PUMP(3)%Mech_Efficiency = CementPumpMechanicalEfficiency
    !PUMP(3)%Vol_Efficiency  = CementPumpVolumetricEfficiency
    !PUMP(3)%Max_Horsepower  = CementPump
    !PUMP(3)%Inertia_Moment  = 23.261341  ! 23.261341 [kg.m^2] = 552 [lb.ft^2]
    !PUMP(3)%Trans_Ratio     = 965.0/CementPumpMaximum
    !PUMP(3)%time_step       = .10
    !
    !PUMP(3)%Flow_Rate       = 0.
    !Call Pump3_OffMode_Solver
    
    
    
    
    
end subroutine Pumps_StartUp